# Recibe los seis valores de la ecuación general
# de la cónica y devuelve los parámetros de la elipse
# [a, b, Cx, Cy, alfa]^T
# 
import sys
import math

n = len( sys.argv )
if n != 7 :
	print("Args: a 2b c 2d 2e g" )
	sys.exit(1)

a = float( sys.argv[1] )
b = float( sys.argv[2] )/2.0
c = float( sys.argv[3] )
d = float( sys.argv[4] )/2.0
e = float( sys.argv[5] )/2.0
g = float( sys.argv[6] )

angulo =  math.atan (  2.0 * b / (a - c) )*90.0/math.pi

aux3 = b*b - a*c

xc = (c*d - b*e)/aux3
yc = (a*e - b*d)/aux3


aux1 = math.fabs( 2.0 * ( a*e*e+ c*d*d + g*b*b - 2.0*b*d*e - a*c*g ) )
aux2 = math.fabs( (b*b-a*c) * ( (c-a)*math.sqrt(1.0 + ( (4.0*b*b)/((a-c)*(a-c)) ) ) - (c+a) ) )
aux3 = math.fabs( (b*b-a*c) * ( (a-c)*math.sqrt(1.0 + ( (4.0*b*b)/((a-c)*(a-c)) ) ) - (c+a) ) )

eje_a = math.sqrt ( aux1 / aux2)
eje_b = math.sqrt ( aux1 / aux3)

if eje_a < eje_b :
	aux1 = eje_a
	eje_a = eje_b
	eje_b = aux1
	if angulo < 0 : 
		angulo += 90.0;
	else :
		angulo -= 90.0;

print("a = ", eje_a);
print("b = ", eje_b);
print("Xc = ", xc );
print("Yc = ", yc );
print("ang = ", angulo);
